#ifndef TRACKHEADER
#define TRACKHEADER
#include <vector>
#include <Vector3.h>
#include <Quaternion.h>

class Track
{
protected:
	std::vector<float> times;
	unsigned int index;
	float ctime;
public:
	Track();
	~Track();
	void SetTime(float time);
	
};


class VTrack : public Track
{
	friend class KeyFrameAnim;
protected:
	std::vector<Vector3> vals;
public:
	VTrack();
	~VTrack();
	Vector3 GetValue();
	void AddValue(float f, Vector3 & v);
};

class QTrack : public Track
{
	friend class KeyFrameAnim;
protected:
	std::vector<Quaternion> vals;
public:
	QTrack();
	~QTrack();
	Quaternion GetValue();
	void AddValue(float f, Quaternion & q);
};


class STrack : public Track
{
	friend class KeyFrameAnim;
protected:
	std::vector<float> vals;
public:
	STrack();
	~STrack();
	float GetValue();
	void AddValue(float f, float v);

};




#endif