#include "Mesh.h"
#include <stdio.h>
#include <vector>

Mesh::Mesh()
{
	numvertices = numfaces = numtvertices = numnormals  =0;
	vertices=NULL;
	tvertices=NULL;
	normals=NULL;
	faces=NULL;

}

Mesh::~Mesh()
{

}

void Mesh::Draw()
{
	glEnable(GL_LIGHTING);
	for (int i = 0; i < numfaces;i++)
	{
		int verts;
		if (faces[i].isTriangle)
		{
			glBegin(GL_TRIANGLES);
			verts = 3;
		}
		else
		{
			glBegin(GL_QUADS);
			verts = 4;
		}
		for (int j = 0; j < verts;j++)
		{
			glNormal3fv((GLfloat*)&normals[faces[i].v[j]-1]);
			glVertex3fv((GLfloat*)&vertices[faces[i].v[j]-1]);
		}
		glEnd();
	}
	glDisable(GL_LIGHTING);

	//	glInterleavedArrays(format,0,vertexbuffer);
	
//	glDrawArrays(GL_TRIANGLES,0,numTriangles);

}
//okay, so it's not the most robust or efficient way to do things. . .
bool Mesh::LoadObj(const char* filename)
{


	FILE * f = fopen(filename,"r");
	if (!f)
		return false;

	free(vertices);
	free(tvertices);
	free(normals);
	free(faces);
	numvertices = numtvertices = numnormals = numfaces = 0;
	int sizevertices = 10;
	int sizetvertices = 10;
	int sizenormals = 10;
	int sizefaces = 10;
	vertices = (vec3*)malloc(sizeof(vec3)*sizevertices);
	tvertices = (vec2*)malloc(sizeof(vec3)*sizetvertices);
	normals = (vec3*)malloc(sizeof(vec3)*sizenormals);
	faces = (facedef*)malloc(sizeof(facedef)*sizefaces);


	while (!feof(f))
	{
		char buff[160];
		fgets(buff,sizeof(buff),f);
		
		switch(buff[0])
		{
		case '#': //comment
			break;
		case 'g': //group
			break;
		case 's': //smoothing group
			break;
		case 'v': //vertex of some sort
			switch(buff[1])
			{
				case ' ': //vertex
				{
					if (sizevertices == numvertices)
					{
						sizevertices*=2;
						vertices = (vec3*)realloc(vertices,sizevertices*sizeof(vec3));
					}
					sscanf(&buff[1],"%f %f %f",&vertices[numvertices].x,&vertices[numvertices].y,&vertices[numvertices].z);
					numvertices++;
				}
				break;
				case 't': //texture vertex
				{

					if (sizetvertices == numtvertices)
					{
						sizetvertices*=2;
						tvertices = (vec2*)realloc(tvertices,sizetvertices*sizeof(vec2));
					}
					sscanf(&buff[1],"%f %f",&tvertices[numtvertices].x,&tvertices[numtvertices].y);
					numtvertices++;
				}
				break;
				case 'n': //normal
				{
					if (sizenormals == numnormals)
					{
						sizenormals*=2;
						normals = (vec3*)realloc(normals,sizenormals*sizeof(vec2));
					}
					sscanf(&buff[1],"%f %f %f",&normals[numnormals].x,&normals[numnormals].y,&normals[numnormals].z);
					numnormals++;
				}
				break;
			}
			break;

		case 'f':
			{

				if (sizefaces == numfaces)
				{
					sizefaces*=2;
					faces = (facedef*)realloc(faces,sizefaces*sizeof(facedef));
				}

				faces[numfaces].isTriangle = false;
				char * rover = &buff[2];

				for (int i = 0; i < 4;i++)
				{
					//get vertex info
					
					while (isspace(*rover)) rover++;

					if (*rover == 0)
					{
						faces[numfaces].isTriangle = true;
						continue;
					}

					sscanf(rover,"%d",&faces[numfaces].v[i]);
					while (isdigit(*++rover));

					if (*rover == ' ') //no normals or vertices!
					{
						faces[numfaces].t[i] = 0;
						faces[numfaces].n[i] = 0;
					}
					else //more data for this node
					{
						rover++; //skip over /
						if (*rover == '/') //no textures
							faces[numfaces].t[i] = 0;
						else
						{
							sscanf(rover,"%d",&faces[numfaces].t[i]);
							while (isdigit(*++rover));
						}

						rover++; //skip over /

						if (*rover == ' ') //no normals
							faces[numfaces].n[i] = 0;
						else
						{
							sscanf(rover,"%d",&faces[numfaces].n[i]);
							while (isdigit(*++rover));
							rover++;
						}
					}
				}
				numfaces++;
			}
			break;
		default:
			continue;
		}
	}

	vertices = (vec3*)realloc(vertices,numvertices*sizeof(vec3));
	tvertices = (vec2*)realloc(tvertices,numtvertices*sizeof(vec2));
	normals = (vec3*)realloc(normals,numnormals*sizeof(vec3));
	faces = (facedef*)realloc(faces,numfaces*sizeof(facedef));

	fclose(f);
	return true;
}
