#include "TimeStamp.h"
#include <SDL.h>

TimeStamp::TimeStamp()
{
	time = SDL_GetTicks();
}

bool operator<(const TimeStamp & t1, const TimeStamp & t2)
{
	return t1.time < t2.time;
}

void
TimeStamp::Reset()
{
	time = SDL_GetTicks();
}

TimeStamp::~TimeStamp()
{
}
	
unsigned int 
TimeStamp::Msec() const
{
	return time;
}

double 
TimeStamp::Interval(const TimeStamp & t) const
{
	return (t.time - time) / 1000.0;
}
