#include "glPrint.h"
#include <stdio.h>

//prints out a string, using the currently applied material 
GLvoid glPrint(unsigned int scale, const char *fmt, ... )
{
	static bool firstTime = true;
	static unsigned int base;
	if (firstTime)
	{
		//generate the display lists
		base = glGenLists(128);
		
		for (int i = 0; i < 128;i++)
		{
			float s = 1.0/16.0;
			int x = i % 16;
			int y = i / 16;

			glNewList(base+i,GL_COMPILE);
			glBegin(GL_QUADS);
			glColor3f(1,1,1);
			glNormal3f(0,0,1);
			
			glTexCoord2f(s*x,y*s);
			glVertex2f(0,0);
			
			glTexCoord2f(s*x,(y+1)*s);
			glVertex2f(0,1);
			
			glTexCoord2f((x+1)*s, (y+1)*s);
			glVertex2f(1,1);
			
			glTexCoord2f((x+1)*s, y*s);
			glVertex2f(1,0);
			glEnd();
			glTranslatef(1,0,0);
			glEndList();
		}
		firstTime = false;

	}
	
	char text[256]; /* Holds our string */
    va_list ap;     /* Pointer to our list of elements */

    /* If there's no text, do nothing */
    if ( fmt == NULL )
	return;

    /* Parses The String For Variables */
    va_start( ap, fmt );
      /* Converts Symbols To Actual Numbers */
      vsprintf( text, fmt, ap );
    va_end( ap );

    /* Pushes the Display List Bits */
    glPushAttrib( GL_LIST_BIT );

    /* Sets base character to 32 */
    glListBase( base - 32 );

    glPushMatrix();

	glScalef(scale,scale,scale);
	/* Draws the text */
    glCallLists( strlen( text ), GL_UNSIGNED_BYTE, text );

    glPopMatrix();
	/* Pops the Display List Bits */
    glPopAttrib( );
}
