#include <SDL.h>
#include <SDL_Image.h>
#include <SDLimprc.h>
#include <memory.h>
//taken from gamedev.net tutorial
SDL_Color GetPixel ( SDL_Surface* pSurface , int x , int y ) 
{
  SDL_Color color ;
  Uint32 col = 0 ;

  //determine position
  char* pPosition = ( char* ) pSurface->pixels ;

  //offset by y
  pPosition += ( pSurface->pitch * y ) ;

  //offset by x
  pPosition += ( pSurface->format->BytesPerPixel * x ) ;

  //copy pixel data
  memcpy ( &col , pPosition , pSurface->format->BytesPerPixel ) ;

  //convert color
  SDL_GetRGB ( col , pSurface->format , &color.r , &color.g , &color.b ) ;
  return ( color ) ;
}


//probably kind of slow
unsigned char *  
ConvertImage(SDL_Surface * image,bool flip)
{

	unsigned char * data = new unsigned char[3*image->w*image->h];
	
	for (int y = 0; y < image->h;y++)
		for (int x = 0; x < image->w;x++)
		{
			SDL_Color c = GetPixel(image,x,y);
			if (flip)
			{
				data[3*((image->h-y-1)*image->w+x)] = c.r;
				data[3*((image->h-y-1)*image->w+x)+1] = c.g;
				data[3*((image->h-y-1)*image->w+x)+2] = c.b;
			}
			else
			{	
				data[3*(y*image->w+x)] = c.r;
				data[3*(y*image->w+x)+1] = c.g;
				data[3*(y*image->w+x)+2] = c.b;
			}
		}

	return data;
}
